local E, L = unpack(select(2, ...));

E.Func = {};

local LSM = LibStub("LibSharedMedia-3.0");

-- Return comma values for number
--	Sourced from http://richard.warburton.it
--	value - target value to format
E.Func["CommaValue"] = function(value)
	local left, num, right = string.match(value, '^([^%d]*%d)(%d*)(.-)$');

	return left .. (num:reverse():gsub('(%d%d%d)', '%1,'):reverse()) .. right;
end

E.Func["SetTemplate"] = function(self, extend, target)
	local tex = LSM:Fetch("background", "backdrop");

	local template = CreateFrame("Frame", nil, self);
	template:SetFrameLevel(self:GetFrameLevel());
	
	if extend then
		template:SetPoint("TOPLEFT", target or self, "TOPLEFT", -1, 1);
		template:SetPoint("TOPRIGHT", target or self, "TOPRIGHT", 1, 1);
		template:SetPoint("BOTTOMLEFT", target or self,"BOTTOMLEFT", -1, -1);
		template:SetPoint("BOTTOMRIGHT", target or self,"BOTTOMRIGHT", 1, -1);
	else
		template:SetAllPoints(true);
	end

	template:SetBackdrop({
		bgFile = tex,
		edgeFile = tex,
		edgeSize = 1,
	});
	template:SetBackdropColor(0.1, 0.1, 0.1);
	template:SetBackdropBorderColor(0, 0, 0);

	if target then
		target.template = template;
	else
		self.template = template;
	end
end

E.Func["SetBackground"] = function(self)
	local tex = LSM:Fetch("background", "backdrop");

	local background = self:CreateTexture("$parentBackground", "BACKGROUND");
	background:SetAllPoints(true);
	background:SetTexture(tex);
	background:SetVertexColor(0.45, 0.45, 0.45);

	self.background = background;
end